from nova.scheduler import weights
from nova.scheduler.weights import numa
from nova import test
from nova.tests.unit.scheduler import fakes

class NUMAWeigherTestCase(test.NoDBTestCase):
    def setUp(self):
        super(NUMAWeigherTestCase, self).setUp()
        self.weight_handler = weights.HostWeightHandler()
        self.weighers = [numa.NUMAWighter()]
        self.cpu_weigher = numa.NUMAWighter()

    def _get_weighed_host(self, hosts, weight_properties=None):
        if weight_properties is None:
            weight_properties = {}
        return self.weight_handler.get_weighed_objects(self.weighers,
                hosts, weight_properties)[0]

    def _get_all_hosts(self):
        host_values = [
            ("host1", "node1", {"cpu_info": '{"model": "Phytium,S2500"}', "numa_topology": fakes.PHYTIUM_S2500_NUMA_TOPOLOGY1}),
            ("host2", "node2", {"cpu_info": '{"model": "Phytium,S2500"}', "numa_topology": fakes.PHYTIUM_S2500_NUMA_TOPOLOGY2})
        ]
        return [fakes.FakeHostState(host, node, values)
                for host, node, values in host_values]

    def test_multiplier_default(self):
        hostinfo_list = self._get_all_hosts()

        weighed_host = self._get_weighed_host(hostinfo_list) # 获取所有host中最好的host
        self.assertEqual('host1', weighed_host.obj.host) # 查看最好的主机的主机名








